## blastem 0.6.2.1

=== Makefile ===
ifndef OS
OS:=$(shell uname -s)
endif
FIXUP:=true

ifeq ($(OS),Windows)
ifndef SDL2_PREFIX
SDL2_PREFIX:="sdl/i686-w64-mingw32"
endif
ifndef GLEW_PREFIX
GLEW_PREFIX:=glew
endif
ifndef GLEW32S_LIB
GLEW32S_LIB:=$(GLEW_PREFIX)/lib/Release/Win32/glew32s.lib
endif

MEM:=mem_win.o
TERMINAL:=terminal_win.o
FONT:=nuklear_ui/font_win.o
NET:=net_win.o
EXE:=.exe
CC:=i686-w64-mingw32-gcc-win32
CFLAGS:=-std=gnu99 -Wreturn-type -Werror=return-type -Werror=implicit-function-declaration -I"$(SDL2_PREFIX)/include/SDL2" -I"$(GLEW_PREFIX)/include" -DGLEW_STATIC
LDFLAGS:= $(GLEW32S_LIB) -L"$(SDL2_PREFIX)/lib" -lm -lmingw32 -lSDL2main -lSDL2 -lws2_32 -lopengl32 -lglu32 -mwindows
CPU:=i686

else

MEM:=mem.o
TERMINAL:=terminal.o
NET:=net.o
EXE:=

HAS_PROC:=$(shell if [ -d /proc ]; then /bin/echo -e -DHAS_PROC; fi)
CFLAGS:=-std=gnu99 -Wreturn-type -Werror=return-type -Werror=implicit-function-declaration -Wno-unused-value $(HAS_PROC) -DHAVE_UNISTD_H -Wno-unused-result

ifeq ($(OS),Darwin)
LIBS=sdl2 glew
FONT:=nuklear_ui/font_mac.o
else
ifdef USE_GLES
LIBS=sdl2 glesv2
CFLAGS+= -DUSE_GLES
else
LIBS=sdl2 glew gl
endif #USE_GLES
FONT:=nuklear_ui/font.o
endif #Darwin

ifdef HOST_ZLIB
LIBS+= zlib
LIBZOBJS=
else
LIBZOBJS=zlib/adler32.o zlib/compress.o zlib/crc32.o zlib/deflate.o zlib/gzclose.o zlib/gzlib.o zlib/gzread.o\
	zlib/gzwrite.o zlib/infback.o zlib/inffast.o zlib/inflate.o zlib/inftrees.o zlib/trees.o zlib/uncompr.o zlib/zutil.o
endif

ifeq ($(OS),Darwin)
#This should really be based on whether or not the C compiler is clang rather than based on the OS
CFLAGS+= -Wno-logical-op-parentheses
endif
ifdef PORTABLE
ifdef USE_GLES
ifndef GLES_LIB
GLES_LIB:=$(shell pkg-config --libs glesv2)
endif
LDFLAGS:=-lm $(GLES_LIB)
else
CFLAGS+= -DGLEW_STATIC -Iglew/include
LDFLAGS:=-lm glew/lib/libGLEW.a
endif

ifeq ($(OS),Darwin)
CFLAGS+= -IFrameworks/SDL2.framework/Headers
LDFLAGS+= -FFrameworks -framework SDL2 -framework OpenGL -framework AppKit
FIXUP:=install_name_tool -change @rpath/SDL2.framework/Versions/A/SDL2 @executable_path/Frameworks/SDL2.framework/Versions/A/SDL2
else
CFLAGS+= -Isdl/include
LDFLAGS+= -Wl,-rpath='$$ORIGIN/lib' -Llib -lSDL2
ifndef USE_GLES
LDFLAGS+= $(shell pkg-config --libs gl)
endif
endif #Darwin

else
ifeq ($(MAKECMDGOALS),libblastem.so)
LDFLAGS:=-lm
else
CFLAGS:=$(shell pkg-config --cflags-only-I $(LIBS)) $(CFLAGS)
LDFLAGS:=-lm $(shell pkg-config --libs $(LIBS))
endif #libblastem.so

ifeq ($(OS),Darwin)
LDFLAGS+= -framework OpenGL -framework AppKit
endif

endif #PORTABLE
endif #Windows

ifndef OPT
ifdef DEBUG
OPT:=-g3 -O0
else
ifdef NOLTO
OPT:=-O2
else
OPT:=-O2 -flto -g -fPIE -D_FORTIFY_SOURCE=2 -fstack-protector-strong -Wformat -Werror=format-security
endif #NOLTO
endif #DEBUG
endif #OPT

CFLAGS:=$(OPT) $(CFLAGS)
LDFLAGS:=$(LDFLAGS) -Wl,-z,relro -Wl,-z,now -fPIE -pie

ifdef Z80_LOG_ADDRESS
CFLAGS+= -DZ80_LOG_ADDRESS
endif

ifdef PROFILE
LDFLAGS+= -Wl,--no-as-needed -lprofiler -Wl,--as-needed
endif
ifdef NOGL
CFLAGS+= -DDISABLE_OPENGL
NONUKLEAR:=1
endif

ifdef M68030
CFLAGS+= -DM68030
endif
ifdef M68020
CFLAGS+= -DM68020
endif
ifdef M68010
CFLAGS+= -DM68010
endif

ifndef CPU
CPU:=$(shell uname -m)
endif

#OpenBSD uses different names for these architectures
ifeq ($(CPU),amd64)
CPU:=x86_64
else
ifeq ($(CPU),i386)
CPU:=i686
endif
endif

TRANSOBJS=gen.o backend.o $(MEM) arena.o tern.o
M68KOBJS=68kinst.o m68k_core.o
ifeq ($(CPU),x86_64)
M68KOBJS+= m68k_core_x86.o
TRANSOBJS+= gen_x86.o backend_x86.o
else
ifeq ($(CPU),i686)
M68KOBJS+= m68k_core_x86.o
TRANSOBJS+= gen_x86.o backend_x86.o
endif
endif

Z80OBJS=z80inst.o z80_to_x86.o
AUDIOOBJS=ym2612.o psg.o wave.o
CONFIGOBJS=config.o tern.o util.o paths.o 
NUKLEAROBJS=$(FONT) nuklear_ui/blastem_nuklear.o nuklear_ui/sfnt.o controller_info.o
RENDEROBJS=render_sdl.o ppm.o
	
ifdef NOZLIB
CFLAGS+= -DDISABLE_ZLIB
else
RENDEROBJS+= $(LIBZOBJS) png.o
endif

MAINOBJS=blastem.o system.o genesis.o debug.o gdb_remote.o vdp.o $(RENDEROBJS) io.o romdb.o hash.o menu.o xband.o \
	realtec.o i2c.o nor.o sega_mapper.o multi_game.o megawifi.o $(NET) serialize.o $(TERMINAL) $(CONFIGOBJS) gst.o \
	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o zip.o bindings.o jcart.o

LIBOBJS=libblastem.o system.o genesis.o debug.o gdb_remote.o vdp.o io.o romdb.o hash.o menu.o xband.o realtec.o \
	i2c.o nor.o sega_mapper.o multi_game.o megawifi.o $(NET) serialize.o $(TERMINAL) $(CONFIGOBJS) gst.o \
	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o jcart.o
	
ifdef NONUKLEAR
CFLAGS+= -DDISABLE_NUKLEAR
else
MAINOBJS+= $(NUKLEAROBJS)
endif

ifeq ($(CPU),x86_64)
CFLAGS+=-DX86_64 -m64
LDFLAGS+=-m64
else
ifeq ($(CPU),i686)
CFLAGS+=-DX86_32 -m32
LDFLAGS+=-m32
else
$(error $(CPU) is not a supported architecture)
endif
endif

ifdef NOZ80
CFLAGS+=-DNO_Z80
else
MAINOBJS+= sms.o $(Z80OBJS)
LIBOBJS+= sms.o $(Z80OBJS)
endif

ifeq ($(OS),Windows)
MAINOBJS+= res.o
endif

ifdef CONFIG_PATH
CFLAGS+= -DCONFIG_PATH='"'$(CONFIG_PATH)'"'
endif

ifdef DATA_PATH
CFLAGS+= -DDATA_PATH='"'$(DATA_PATH)'"'
endif

ALL=dis$(EXE) zdis$(EXE) stateview$(EXE) vgmplay$(EXE) blastem$(EXE)
ifneq ($(OS),Windows)
ALL+= termhelper
endif

ifeq ($(MAKECMDGOALS),libblastem.so)
CFLAGS+= -fpic -DIS_LIB
endif

all : $(ALL)

libblastem.so : $(LIBOBJS)
	$(CC) -shared -o $@ $^ $(LDFLAGS)

blastem$(EXE) : $(MAINOBJS)
	$(CC) -o $@ $^ $(LDFLAGS)
	$(FIXUP) ./$@
	
blastjag$(EXE) : jaguar.o jag_video.o $(RENDEROBJS) serialize.o $(M68KOBJS) $(TRANSOBJS) $(CONFIGOBJS)
	$(CC) -o $@ $^ $(LDFLAGS)

dis$(EXE) : dis.o 68kinst.o tern.o vos_program_module.o
	$(CC) -o $@ $^ $(OPT) $(LDFLAGS)
	
jagdis : jagdis.o jagcpu.o tern.o
	$(CC) -o $@ $^

zdis$(EXE) : zdis.o z80inst.o
	$(CC) -o $@ $^ $(LDFLAGS)

libemu68k.a : $(M68KOBJS) $(TRANSOBJS)
	ar rcs libemu68k.a $(M68KOBJS) $(TRANSOBJS)

trans : trans.o serialize.o $(M68KOBJS) $(TRANSOBJS) util.o
	$(CC) -o trans trans.o $(M68KOBJS) $(TRANSOBJS) util.o $(OPT)

transz80 : transz80.o $(Z80OBJS) $(TRANSOBJS)
	$(CC) -o transz80 transz80.o $(Z80OBJS) $(TRANSOBJS)

ztestrun : ztestrun.o serialize.o $(Z80OBJS) $(TRANSOBJS)
	$(CC) -o ztestrun ztestrun.o $(Z80OBJS) $(TRANSOBJS) $(OPT)

ztestgen : ztestgen.o z80inst.o
	$(CC) -ggdb -o ztestgen ztestgen.o z80inst.o

stateview$(EXE) : stateview.o vdp.o $(RENDEROBJS) serialize.o $(CONFIGOBJS) gst.o
	$(CC) -o $@ $^ $(LDFLAGS)
	$(FIXUP) ./$@

vgmplay$(EXE) : vgmplay.o $(RENDEROBJS) serialize.o $(CONFIGOBJS) $(AUDIOOBJS)
	$(CC) -o $@ $^ $(LDFLAGS)
	$(FIXUP) ./$@

blastcpm : blastcpm.o util.o serialize.o $(Z80OBJS) $(TRANSOBJS)
	$(CC) -o $@ $^ $(OPT)

test : test.o vdp.o
	$(CC) -o test test.o vdp.o $(LDFLAGS)

testgst : testgst.o gst.o
	$(CC) -o testgst testgst.o gst.o

test_x86 : test_x86.o gen_x86.o gen.o
	$(CC) -o test_x86 test_x86.o gen_x86.o gen.o

test_arm : test_arm.o gen_arm.o mem.o gen.o
	$(CC) -o test_arm test_arm.o gen_arm.o mem.o gen.o
	
test_int_timing : test_int_timing.o vdp.o
	$(CC) -o $@ $^

gen_fib : gen_fib.o gen_x86.o mem.o
	$(CC) -o gen_fib gen_fib.o gen_x86.o mem.o

offsets : offsets.c z80_to_x86.h m68k_core.h
	$(CC) -o offsets offsets.c

vos_prog_info : vos_prog_info.o vos_program_module.o
	$(CC) -o vos_prog_info vos_prog_info.o vos_program_module.o

%.o : %.S
	$(CC) -c -o $@ $<

%.o : %.c
	$(CC) $(CFLAGS) -c -o $@ $<
  
%.o : %.m
	$(CC) $(CFLAGS) -c -o $@ $<

%.png : %.xcf
	xcf2png $< > $@

%.tiles : %.spec
	./img2tiles.py -s $< $@

%.bin : %.s68
	vasmm68k_mot -Fbin -m68000 -no-opt -spaces -o $@ -L $@.list $<

%.bin : %.sz8
	vasmz80_mot -Fbin -spaces -o $@ $<
res.o : blastem.rc
	i686-w64-mingw32-windres blastem.rc res.o

arrow.tiles : arrow.png
cursor.tiles : cursor.png
font_interlace_variable.tiles : font_interlace_variable.png
button.tiles : button.png
font.tiles : font.png

menu.bin : font_interlace_variable.tiles arrow.tiles cursor.tiles button.tiles font.tiles

clean :
	rm -rf $(ALL) trans ztestrun ztestgen *.o nuklear_ui/*.o zlib/*.o test

=== debian/changelog ===
blastem (0.6.2.1-1) unstable; urgency=medium

  * New upstream release
  * Fixed the FTBFS due to enabled hardening build flags

 -- Carlos Donizete Froes <coringao@riseup.net>  Mon, 11 Feb 2019 03:56:29 -0200

blastem (0.6.2-1) unstable; urgency=medium

  * Initial release (Closes: #919540)

 -- Carlos Donizete Froes <coringao@riseup.net>  Thu, 24 Jan 2019 03:08:50 -0200

=== debian/control ===
Source: blastem
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Carlos Donizete Froes <coringao@riseup.net>
Build-Depends: debhelper (>= 12),
               libasound2-dev,
               libglew-dev,
               libsdl2-dev,
               libsdl2-mixer-dev,
               zlib1g-dev
Standards-Version: 4.3.0
Homepage: https://www.retrodev.com/blastem
Vcs-Browser: https://salsa.debian.org/games-team/blastem
Vcs-Git: https://salsa.debian.org/games-team/blastem.git

Package: blastem
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast and accurate Genesis emulator
 BlastEm is a highly precise multi-system emulator that emulates
 the Sega Genesis/Mega Drive, Master System and Game Gear.
 .
 Despite this high accuracy, even the most demanding software runs
 at full speed on modest hardware.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	make HOST_ZLIB=1 CONFIG_PATH=/etc/blastem \
	DATA_PATH=/usr/share/games/blastem

## blastem 0.6.3

=== Makefile ===
--- 
+++ 
@@ -193,7 +193,7 @@
 CFLAGS+=-DX86_32 -m32
 LDFLAGS+=-m32
 else
-$(error $(CPU) is not a supported architecture)
+# $(error $(CPU) is not a supported architecture)
 endif
 endif

=== debian/changelog ===
blastem (0.6.3-1) unstable; urgency=medium

  * New upstream release

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 09 Mar 2019 22:10:42 -0300

## blastem 0.6.3.2

=== debian/changelog ===
blastem (0.6.3.2-1) unstable; urgency=medium

  * New upstream release: 0.6.3.2

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 29 Jun 2019 12:08:17 -0300

blastem (0.6.3.1-1) unstable; urgency=medium

  * New upstream release (Closes: #926498)
  * Fix FTCBFS: (Thanks - Helmut Grohne)
    + Let dh_auto_build pass cross tools to make
  * Fixed spelling error in d/upstream/metadata

 -- Carlos Donizete Froes <coringao@riseup.net>  Fri, 28 Jun 2019 22:52:53 -0300

## blastem 0.6.3.3

=== Makefile ===
--- 
+++ 
@@ -1,28 +1,45 @@
+#disable built-in rules
+.SUFFIXES :
+
+PKG_CONFIG ?= pkg-config
+
 ifndef OS
 OS:=$(shell uname -s)
 endif
 FIXUP:=true
 
+BUNDLED_LIBZ:=zlib/adler32.o zlib/compress.o zlib/crc32.o zlib/deflate.o zlib/gzclose.o zlib/gzlib.o zlib/gzread.o\
+	zlib/gzwrite.o zlib/infback.o zlib/inffast.o zlib/inflate.o zlib/inftrees.o zlib/trees.o zlib/uncompr.o zlib/zutil.o
+
 ifeq ($(OS),Windows)
-ifndef SDL2_PREFIX
-SDL2_PREFIX:="sdl/i686-w64-mingw32"
-endif
-ifndef GLEW_PREFIX
+
 GLEW_PREFIX:=glew
-endif
-ifndef GLEW32S_LIB
-GLEW32S_LIB:=$(GLEW_PREFIX)/lib/Release/Win32/glew32s.lib
-endif
-
 MEM:=mem_win.o
 TERMINAL:=terminal_win.o
 FONT:=nuklear_ui/font_win.o
 NET:=net_win.o
 EXE:=.exe
+SO:=dll
+CPU:=i686
+ifeq ($(CPU),i686)
 CC:=i686-w64-mingw32-gcc-win32
-CFLAGS:=-std=gnu99 -Wreturn-type -Werror=return-type -Werror=implicit-function-declaration -I"$(SDL2_PREFIX)/include/SDL2" -I"$(GLEW_PREFIX)/include" -DGLEW_STATIC
-LDFLAGS:= $(GLEW32S_LIB) -L"$(SDL2_PREFIX)/lib" -lm -lmingw32 -lSDL2main -lSDL2 -lws2_32 -lopengl32 -lglu32 -mwindows
-CPU:=i686
+WINDRES:=i686-w64-mingw32-windres
+GLUDIR:=Win32
+SDL2_PREFIX:="sdl/i686-w64-mingw32"
+else
+CC:=x86_64-w64-mingw32-gcc-win32
+WINDRES:=x86_64-w64-mingw32-windres
+SDL2_PREFIX:="sdl/x86_64-w64-mingw32"
+GLUDIR:=x64
+endif
+GLEW32S_LIB:=$(GLEW_PREFIX)/lib/Release/$(GLUDIR)/glew32s.lib
+CFLAGS:=-std=gnu99 -Wreturn-type -Werror=return-type -Werror=implicit-function-declaration
+LDFLAGS:=-lm -lmingw32 -lws2_32 -mwindows
+ifneq ($(MAKECMDGOALS),libblastem.dll)
+CFLAGS+= -I"$(SDL2_PREFIX)/include/SDL2" -I"$(GLEW_PREFIX)/include" -DGLEW_STATIC
+LDFLAGS+= $(GLEW32S_LIB) -L"$(SDL2_PREFIX)/lib" -lSDL2main -lSDL2 -lopengl32 -lglu32
+endif
+LIBZOBJS=$(BUNDLED_LIBZ)
 
 else
 
@@ -37,6 +54,16 @@
 ifeq ($(OS),Darwin)
 LIBS=sdl2 glew
 FONT:=nuklear_ui/font_mac.o
+SO:=dylib
+else
+SO:=so
+
+ifdef USE_FBDEV
+LIBS=alsa
+ifndef NOGL
+LIBS+=glesv2 egl
+endif
+CFLAGS+= -DUSE_GLES -DUSE_FBDEV -pthread
 else
 ifdef USE_GLES
 LIBS=sdl2 glesv2
@@ -44,6 +71,7 @@
 else
 LIBS=sdl2 glew gl
 endif #USE_GLES
+endif #USE_FBDEV
 FONT:=nuklear_ui/font.o
 endif #Darwin
 
@@ -51,8 +79,7 @@
 LIBS+= zlib
 LIBZOBJS=
 else
-LIBZOBJS=zlib/adler32.o zlib/compress.o zlib/crc32.o zlib/deflate.o zlib/gzclose.o zlib/gzlib.o zlib/gzread.o\
-	zlib/gzwrite.o zlib/infback.o zlib/inffast.o zlib/inflate.o zlib/inftrees.o zlib/trees.o zlib/uncompr.o zlib/zutil.o
+LIBZOBJS=$(BUNDLED_LIBZ)
 endif
 
 ifeq ($(OS),Darwin)
@@ -62,7 +89,7 @@
 ifdef PORTABLE
 ifdef USE_GLES
 ifndef GLES_LIB
-GLES_LIB:=$(shell pkg-config --libs glesv2)
+GLES_LIB:=$(shell $(PKG_CONFIG) --libs glesv2)
 endif
 LDFLAGS:=-lm $(GLES_LIB)
 else
@@ -78,16 +105,19 @@
 CFLAGS+= -Isdl/include
 LDFLAGS+= -Wl,-rpath='$$ORIGIN/lib' -Llib -lSDL2
 ifndef USE_GLES
-LDFLAGS+= $(shell pkg-config --libs gl)
+LDFLAGS+= $(shell $(PKG_CONFIG) --libs gl)
 endif
 endif #Darwin
 
 else
-ifeq ($(MAKECMDGOALS),libblastem.so)
+ifeq ($(MAKECMDGOALS),libblastem.$(SO))
 LDFLAGS:=-lm
 else
-CFLAGS:=$(shell pkg-config --cflags-only-I $(LIBS)) $(CFLAGS)
-LDFLAGS:=-lm $(shell pkg-config --libs $(LIBS))
+CFLAGS:=$(shell $(PKG_CONFIG) --cflags-only-I $(LIBS)) $(CFLAGS)
+LDFLAGS:=-lm $(shell $(PKG_CONFIG) --libs $(LIBS))
+ifdef USE_FBDEV
+LDFLAGS+= -pthread
+endif
 endif #libblastem.so
 
 ifeq ($(OS),Darwin)
@@ -110,18 +140,18 @@
 endif #OPT
 
 CFLAGS:=$(OPT) $(CFLAGS)
-LDFLAGS:=$(LDFLAGS) -Wl,-z,relro -Wl,-z,now -fPIE -pie
+LDFLAGS:=$(OPT) $(LDFLAGS) -Wl,-z,relro -Wl,-z,now -fPIE -pie
 
 ifdef Z80_LOG_ADDRESS
 CFLAGS+= -DZ80_LOG_ADDRESS
 endif
 
 ifdef PROFILE
-LDFLAGS+= -Wl,--no-as-needed -lprofiler -Wl,--as-needed
+PROFFLAGS:= -Wl,--no-as-needed -lprofiler -Wl,--as-needed
+CFLAGS+= -g3
 endif
 ifdef NOGL
 CFLAGS+= -DDISABLE_OPENGL
-NONUKLEAR:=1
 endif
 
 ifdef M68030
@@ -148,23 +178,34 @@
 endif
 
 TRANSOBJS=gen.o backend.o $(MEM) arena.o tern.o
-M68KOBJS=68kinst.o m68k_core.o
+M68KOBJS=68kinst.o
+
+ifdef NEW_CORE
+Z80OBJS=z80.o z80inst.o
+M68KOBJS+= m68k.o
+CFLAGS+= -DNEW_CORE
+else
+Z80OBJS=z80inst.o z80_to_x86.o
 ifeq ($(CPU),x86_64)
-M68KOBJS+= m68k_core_x86.o
+M68KOBJS+= m68k_core.o m68k_core_x86.o
 TRANSOBJS+= gen_x86.o backend_x86.o
 else
 ifeq ($(CPU),i686)
-M68KOBJS+= m68k_core_x86.o
+M68KOBJS+= m68k_core.o m68k_core_x86.o
 TRANSOBJS+= gen_x86.o backend_x86.o
 endif
 endif
-
-Z80OBJS=z80inst.o z80_to_x86.o
+endif
 AUDIOOBJS=ym2612.o psg.o wave.o
-CONFIGOBJS=config.o tern.o util.o paths.o 
-NUKLEAROBJS=$(FONT) nuklear_ui/blastem_nuklear.o nuklear_ui/sfnt.o controller_info.o
-RENDEROBJS=render_sdl.o ppm.o
-	
+CONFIGOBJS=config.o tern.o util.o paths.o
+NUKLEAROBJS=$(FONT) nuklear_ui/blastem_nuklear.o nuklear_ui/sfnt.o
+RENDEROBJS=ppm.o controller_info.o render_audio.o
+ifdef USE_FBDEV
+RENDEROBJS+= render_fbdev.o
+else
+RENDEROBJS+= render_sdl.o
+endif
+
 ifdef NOZLIB
 CFLAGS+= -DDISABLE_ZLIB
 else
@@ -175,10 +216,10 @@
 	realtec.o i2c.o nor.o sega_mapper.o multi_game.o megawifi.o $(NET) serialize.o $(TERMINAL) $(CONFIGOBJS) gst.o \
 	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o zip.o bindings.o jcart.o
 
-LIBOBJS=libblastem.o system.o genesis.o debug.o gdb_remote.o vdp.o io.o romdb.o hash.o menu.o xband.o realtec.o \
+LIBOBJS=libblastem.o system.o genesis.o debug.o gdb_remote.o vdp.o io.o romdb.o hash.o xband.o realtec.o \
 	i2c.o nor.o sega_mapper.o multi_game.o megawifi.o $(NET) serialize.o $(TERMINAL) $(CONFIGOBJS) gst.o \
-	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o jcart.o
-	
+	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o jcart.o rom.db.o
+
 ifdef NONUKLEAR
 CFLAGS+= -DDISABLE_NUKLEAR
 else
@@ -221,27 +262,30 @@
 ALL+= termhelper
 endif
 
-ifeq ($(MAKECMDGOALS),libblastem.so)
+ifeq ($(MAKECMDGOALS),libblastem.$(SO))
 CFLAGS+= -fpic -DIS_LIB
 endif
 
 all : $(ALL)
 
-libblastem.so : $(LIBOBJS)
+libblastem.$(SO) : $(LIBOBJS)
 	$(CC) -shared -o $@ $^ $(LDFLAGS)
 
 blastem$(EXE) : $(MAINOBJS)
-	$(CC) -o $@ $^ $(LDFLAGS)
+	$(CC) -o $@ $^ $(LDFLAGS) $(PROFFLAGS)
 	$(FIXUP) ./$@
-	
+
 blastjag$(EXE) : jaguar.o jag_video.o $(RENDEROBJS) serialize.o $(M68KOBJS) $(TRANSOBJS) $(CONFIGOBJS)
+	$(CC) -o $@ $^ $(LDFLAGS)
+
+termhelper : termhelper.o
 	$(CC) -o $@ $^ $(LDFLAGS)
 
 dis$(EXE) : dis.o 68kinst.o tern.o vos_program_module.o
 	$(CC) -o $@ $^ $(OPT) $(LDFLAGS)
-	
+
 jagdis : jagdis.o jagcpu.o tern.o
-	$(CC) -o $@ $^
+	$(CC) -o $@ $^ $(LDFLAGS)
 
 zdis$(EXE) : zdis.o z80inst.o
 	$(CC) -o $@ $^ $(LDFLAGS)
@@ -256,7 +300,7 @@
 	$(CC) -o transz80 transz80.o $(Z80OBJS) $(TRANSOBJS)
 
 ztestrun : ztestrun.o serialize.o $(Z80OBJS) $(TRANSOBJS)
-	$(CC) -o ztestrun ztestrun.o $(Z80OBJS) $(TRANSOBJS) $(OPT)
+	$(CC) -o ztestrun $^ $(OPT)
 
 ztestgen : ztestgen.o z80inst.o
 	$(CC) -ggdb -o ztestgen ztestgen.o z80inst.o
@@ -270,7 +314,7 @@
 	$(FIXUP) ./$@
 
 blastcpm : blastcpm.o util.o serialize.o $(Z80OBJS) $(TRANSOBJS)
-	$(CC) -o $@ $^ $(OPT)
+	$(CC) -o $@ $^ $(OPT) $(PROFFLAGS)
 
 test : test.o vdp.o
 	$(CC) -o test test.o vdp.o $(LDFLAGS)
@@ -283,7 +327,7 @@
 
 test_arm : test_arm.o gen_arm.o mem.o gen.o
 	$(CC) -o test_arm test_arm.o gen_arm.o mem.o gen.o
-	
+
 test_int_timing : test_int_timing.o vdp.o
 	$(CC) -o $@ $^
 
@@ -296,12 +340,21 @@
 vos_prog_info : vos_prog_info.o vos_program_module.o
 	$(CC) -o vos_prog_info vos_prog_info.o vos_program_module.o
 
+m68k.c : m68k.cpu cpu_dsl.py
+	./cpu_dsl.py -d call $< > $@
+
+%.c : %.cpu cpu_dsl.py
+	./cpu_dsl.py -d goto $< > $@
+
+%.db.c : %.db
+	sed $< -e 's/"/\\"/g' -e 's/^\(.*\)$$/"\1\\n"/' -e'1s/^\(.*\)$$/const char $(shell echo $< | tr '.' '_')_data[] = \1/' -e '$$s/^\(.*\)$$/\1;/' > $@
+
 %.o : %.S
 	$(CC) -c -o $@ $<
 
 %.o : %.c
 	$(CC) $(CFLAGS) -c -o $@ $<
-  
+
 %.o : %.m
 	$(CC) $(CFLAGS) -c -o $@ $<
 
@@ -317,7 +370,7 @@
 %.bin : %.sz8
 	vasmz80_mot -Fbin -spaces -o $@ $<
 res.o : blastem.rc
-	i686-w64-mingw32-windres blastem.rc res.o
+	$(WINDRES) blastem.rc res.o
 
 arrow.tiles : arrow.png
 cursor.tiles : cursor.png

=== debian/changelog ===
blastem (0.6.3.3-3) unstable; urgency=medium

  * Team upload.

  [ Reiner Herrmann ]
  * Fix FTBFS with GCC 10 (Closes: #957048)

  [ Markus Koschany ]
  * Declare compliance with Debian Policy 4.5.0.
  * Switch to debhelper-compat = 13.

 -- Markus Koschany <apo@debian.org>  Sun, 26 Jul 2020 14:37:00 +0200

blastem (0.6.3.3-2) unstable; urgency=medium

  * debian/control:
    + Bumped Standards-Version to 4.4.1.
    + Set Rules-Requires-Root to no.
  * debian/copyright:
    + Added copyright information for contact.
    + Official upstream link changed.

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 16 Nov 2019 03:26:12 -0300

blastem (0.6.3.3-1) unstable; urgency=medium

  * New upstream release: 0.6.3.3
  * Using new DH level format. Consequently:
    - debian/compat: removed.
    + debian/control: changed from 'debhelper' to 'debhelper-compat' in
      Build-Depends field and bumped level to 12.
  * debian/control:
    + Bumped Standards-Version to 4.4.0.

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 03 Aug 2019 01:00:15 -0300

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Carlos Donizete Froes <coringao@riseup.net>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 13),
                libasound2-dev,
                libglew-dev,
                libsdl2-dev,
                libsdl2-mixer-dev,
                zlib1g-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.retrodev.com/blastem
 Vcs-Browser: https://salsa.debian.org/games-team/blastem
 Vcs-Git: https://salsa.debian.org/games-team/blastem.git

=== debian/rules ===
--- 
+++ 
@@ -7,5 +7,5 @@
 	dh $@
 
 override_dh_auto_build:
-	make HOST_ZLIB=1 CONFIG_PATH=/etc/blastem \
+	dh_auto_build -- HOST_ZLIB=1 CONFIG_PATH=/etc/blastem \
 	DATA_PATH=/usr/share/games/blastem

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
  https://gitlab.com/coringao/blastem/tags \
  .*/blastem-(\d\S+)\.(?:tar\.(?:gz|bz2))

## blastem 0.6.3.4

=== Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 GLUDIR:=x64
 endif
 GLEW32S_LIB:=$(GLEW_PREFIX)/lib/Release/$(GLUDIR)/glew32s.lib
-CFLAGS:=-std=gnu99 -Wreturn-type -Werror=return-type -Werror=implicit-function-declaration
+CFLAGS:=-std=gnu99 -Wreturn-type -Werror=return-type -Werror=implicit-function-declaration -Wpointer-arith -Werror=pointer-arith
 LDFLAGS:=-lm -lmingw32 -lws2_32 -mwindows
 ifneq ($(MAKECMDGOALS),libblastem.dll)
 CFLAGS+= -I"$(SDL2_PREFIX)/include/SDL2" -I"$(GLEW_PREFIX)/include" -DGLEW_STATIC
@@ -49,7 +49,7 @@
 EXE:=
 
 HAS_PROC:=$(shell if [ -d /proc ]; then /bin/echo -e -DHAS_PROC; fi)
-CFLAGS:=-std=gnu99 -Wreturn-type -Werror=return-type -Werror=implicit-function-declaration -Wno-unused-value $(HAS_PROC) -DHAVE_UNISTD_H -Wno-unused-result
+CFLAGS:=-std=gnu99 -Wreturn-type -Werror=return-type -Werror=implicit-function-declaration -Wno-unused-value  -Wpointer-arith -Werror=pointer-arith $(HAS_PROC) -DHAVE_UNISTD_H -Wno-unused-result
 
 ifeq ($(OS),Darwin)
 LIBS=sdl2 glew
@@ -98,16 +98,18 @@
 endif
 
 ifeq ($(OS),Darwin)
-CFLAGS+= -IFrameworks/SDL2.framework/Headers
-LDFLAGS+= -FFrameworks -framework SDL2 -framework OpenGL -framework AppKit
+SDL_INCLUDE_PATH:=Frameworks/SDL2.framework/Headers
+CFLAGS+=  -mmacosx-version-min=10.10
+LDFLAGS+= -FFrameworks -framework SDL2 -framework OpenGL -framework AppKit -mmacosx-version-min=10.10
 FIXUP:=install_name_tool -change @rpath/SDL2.framework/Versions/A/SDL2 @executable_path/Frameworks/SDL2.framework/Versions/A/SDL2
 else
-CFLAGS+= -Isdl/include
+SDL_INCLUDE_PATH:=sdl/include
 LDFLAGS+= -Wl,-rpath='$$ORIGIN/lib' -Llib -lSDL2
 ifndef USE_GLES
 LDFLAGS+= $(shell $(PKG_CONFIG) --libs gl)
 endif
 endif #Darwin
+CFLAGS+= -I$(SDL_INCLUDE_PATH)
 
 else
 ifeq ($(MAKECMDGOALS),libblastem.$(SO))
@@ -134,7 +136,7 @@
 ifdef NOLTO
 OPT:=-O2
 else
-OPT:=-O2 -flto -g -fPIE -D_FORTIFY_SOURCE=2 -fstack-protector-strong -Wformat -Werror=format-security
+OPT:=-O2 -flto -g -fPIE -D_FORTIFY_SOURCE=2 -fstack-protector-strong -Wno-stringop-overflow
 endif #NOLTO
 endif #DEBUG
 endif #OPT
@@ -181,7 +183,7 @@
 M68KOBJS=68kinst.o
 
 ifdef NEW_CORE
-Z80OBJS=z80.o z80inst.o
+Z80OBJS=z80.o z80inst.o 
 M68KOBJS+= m68k.o
 CFLAGS+= -DNEW_CORE
 else
@@ -196,16 +198,16 @@
 endif
 endif
 endif
-AUDIOOBJS=ym2612.o psg.o wave.o
-CONFIGOBJS=config.o tern.o util.o paths.o
+AUDIOOBJS=ym2612.o psg.o wave.o vgm.o event_log.o render_audio.o
+CONFIGOBJS=config.o tern.o util.o paths.o 
 NUKLEAROBJS=$(FONT) nuklear_ui/blastem_nuklear.o nuklear_ui/sfnt.o
-RENDEROBJS=ppm.o controller_info.o render_audio.o
+RENDEROBJS=ppm.o controller_info.o
 ifdef USE_FBDEV
 RENDEROBJS+= render_fbdev.o
 else
 RENDEROBJS+= render_sdl.o
 endif
-
+	
 ifdef NOZLIB
 CFLAGS+= -DDISABLE_ZLIB
 else
@@ -214,12 +216,12 @@
 
 MAINOBJS=blastem.o system.o genesis.o debug.o gdb_remote.o vdp.o $(RENDEROBJS) io.o romdb.o hash.o menu.o xband.o \
 	realtec.o i2c.o nor.o sega_mapper.o multi_game.o megawifi.o $(NET) serialize.o $(TERMINAL) $(CONFIGOBJS) gst.o \
-	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o zip.o bindings.o jcart.o
+	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o zip.o bindings.o jcart.o gen_player.o
 
 LIBOBJS=libblastem.o system.o genesis.o debug.o gdb_remote.o vdp.o io.o romdb.o hash.o xband.o realtec.o \
 	i2c.o nor.o sega_mapper.o multi_game.o megawifi.o $(NET) serialize.o $(TERMINAL) $(CONFIGOBJS) gst.o \
-	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o jcart.o rom.db.o
-
+	$(M68KOBJS) $(TRANSOBJS) $(AUDIOOBJS) saves.o jcart.o rom.db.o gen_player.o $(LIBZOBJS)
+	
 ifdef NONUKLEAR
 CFLAGS+= -DDISABLE_NUKLEAR
 else
@@ -233,7 +235,7 @@
 ifeq ($(CPU),i686)
 CFLAGS+=-DX86_32 -m32
 LDFLAGS+=-m32
-else
+# else
 # $(error $(CPU) is not a supported architecture)
 endif
 endif
@@ -257,13 +259,17 @@
 CFLAGS+= -DDATA_PATH='"'$(DATA_PATH)'"'
 endif
 
-ALL=dis$(EXE) zdis$(EXE) stateview$(EXE) vgmplay$(EXE) blastem$(EXE)
+ifdef FONT_PATH
+CFLAGS+= -DFONT_PATH='"'$(FONT_PATH)'"'
+endif
+
+ALL=dis$(EXE) zdis$(EXE) vgmplay$(EXE) blastem$(EXE)
 ifneq ($(OS),Windows)
 ALL+= termhelper
 endif
 
 ifeq ($(MAKECMDGOALS),libblastem.$(SO))
-CFLAGS+= -fpic -DIS_LIB
+CFLAGS+= -fno-common -fpic -DIS_LIB
 endif
 
 all : $(ALL)
@@ -274,7 +280,7 @@
 blastem$(EXE) : $(MAINOBJS)
 	$(CC) -o $@ $^ $(LDFLAGS) $(PROFFLAGS)
 	$(FIXUP) ./$@
-
+	
 blastjag$(EXE) : jaguar.o jag_video.o $(RENDEROBJS) serialize.o $(M68KOBJS) $(TRANSOBJS) $(CONFIGOBJS)
 	$(CC) -o $@ $^ $(LDFLAGS)
 
@@ -283,7 +289,7 @@
 
 dis$(EXE) : dis.o 68kinst.o tern.o vos_program_module.o
 	$(CC) -o $@ $^ $(OPT) $(LDFLAGS)
-
+	
 jagdis : jagdis.o jagcpu.o tern.o
 	$(CC) -o $@ $^ $(LDFLAGS)
 
@@ -294,7 +300,7 @@
 	ar rcs libemu68k.a $(M68KOBJS) $(TRANSOBJS)
 
 trans : trans.o serialize.o $(M68KOBJS) $(TRANSOBJS) util.o
-	$(CC) -o trans trans.o $(M68KOBJS) $(TRANSOBJS) util.o $(OPT)
+	$(CC) -o $@ $^ $(OPT)
 
 transz80 : transz80.o $(Z80OBJS) $(TRANSOBJS)
 	$(CC) -o transz80 transz80.o $(Z80OBJS) $(TRANSOBJS)
@@ -305,10 +311,6 @@
 ztestgen : ztestgen.o z80inst.o
 	$(CC) -ggdb -o ztestgen ztestgen.o z80inst.o
 
-stateview$(EXE) : stateview.o vdp.o $(RENDEROBJS) serialize.o $(CONFIGOBJS) gst.o
-	$(CC) -o $@ $^ $(LDFLAGS)
-	$(FIXUP) ./$@
-
 vgmplay$(EXE) : vgmplay.o $(RENDEROBJS) serialize.o $(CONFIGOBJS) $(AUDIOOBJS)
 	$(CC) -o $@ $^ $(LDFLAGS)
 	$(FIXUP) ./$@
@@ -317,7 +319,7 @@
 	$(CC) -o $@ $^ $(OPT) $(PROFFLAGS)
 
 test : test.o vdp.o
-	$(CC) -o test test.o vdp.o $(LDFLAGS)
+	$(CC) -o test test.o vdp.o
 
 testgst : testgst.o gst.o
 	$(CC) -o testgst testgst.o gst.o
@@ -327,7 +329,7 @@
 
 test_arm : test_arm.o gen_arm.o mem.o gen.o
 	$(CC) -o test_arm test_arm.o gen_arm.o mem.o gen.o
-
+	
 test_int_timing : test_int_timing.o vdp.o
 	$(CC) -o $@ $^
 
@@ -339,7 +341,7 @@
 
 vos_prog_info : vos_prog_info.o vos_program_module.o
 	$(CC) -o vos_prog_info vos_prog_info.o vos_program_module.o
-
+	
 m68k.c : m68k.cpu cpu_dsl.py
 	./cpu_dsl.py -d call $< > $@
 
@@ -354,7 +356,7 @@
 
 %.o : %.c
 	$(CC) $(CFLAGS) -c -o $@ $<
-
+  
 %.o : %.m
 	$(CC) $(CFLAGS) -c -o $@ $<

=== debian/changelog ===
blastem (0.6.3.4-3) unstable; urgency=medium

  * Team Upload
  * Limit to architectures supported by upstream (Closes: #976494)

  [ Stéphane Blondon ]
  * re-add manpage as debian specific (Closes: #1037032)
  * Add synopsis section and reorder usage section

  [ Patrice Duroux ]
  * Update debian/watch. (Closes: #1089924)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 08 Feb 2025 18:04:20 +0100

blastem (0.6.3.4-2) unstable; urgency=medium

  * Team Upload.
  * upstream/metadata: remove extraneous tags

  [ Bernhard Übelacker ]
  * fix Segfault when trying to open rom or access system settings
    (Closes: #1054661)

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database.
  * Remove obsolete fields from debian/upstream/metadata
  * Update standards version to 4.6.2, no changes needed.

 -- Alexandre Detiste <tchet@debian.org>  Wed, 08 May 2024 18:57:23 +0200

blastem (0.6.3.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.6.3.4.
  * Declare compliance with Debian Policy 4.6.0.
  * Update debian/watch.
  * Drop gcc10.patch. Fixed upstream.
  * Fix FTCBFS: Pass CPU variable to make.
    Thanks to Helmut Grohne for the patch. (Closes: #956347)

 -- Markus Koschany <apo@debian.org>  Fri, 24 Sep 2021 22:14:33 +0200

=== debian/control ===
--- 
+++ 
@@ -9,14 +9,14 @@
                libsdl2-dev,
                libsdl2-mixer-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.retrodev.com/blastem
 Vcs-Browser: https://salsa.debian.org/games-team/blastem
 Vcs-Git: https://salsa.debian.org/games-team/blastem.git
 
 Package: blastem
-Architecture: any
+Architecture: amd64 i386
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast and accurate Genesis emulator
  BlastEm is a highly precise multi-system emulator that emulates

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- HOST_ZLIB=1 CONFIG_PATH=/etc/blastem \
	CPU=$(DEB_HOST_GNU_CPU) \
	DATA_PATH=/usr/share/games/blastem

override_dh_auto_test:
	#FTBFS because of "undefined references"

=== debian/watch ===
version=4
opts=searchmode=plain \
https://gitlab.com/coringao/blastem/tags?sort=updated_desc -/archive/[^/]+/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
